#include <stdio.h>
#include <stdlib.h>

#define MAX_n 100
#define INF 1000000

int min (int a, int b) {
  return (a <= b ? a : b);
}

int moneda (int * d, int i, int j) {
  if (j == 0) {
    return 0;
  } else if (i == 0) {
           return INF;
         } else if (d[i] > j) {
                   return moneda(d,i-1,j);
                } else return (min(moneda(d,i-1,j),1+moneda(d,i,j-d[i])));
}

int main (int argc, char *argv[]) {
  int d[MAX_n+1]; // desperdicio la celda d[0] para facilitar la lectura
  int i;

  int k = atoi(argv[argc-1]);
  int n = argc - 2;

  if (n < 1 || n > MAX_n) {
    printf("Wrong number of arguments.\n");
    return 1;
  }

  for (i = 1; i <= n; i++) d[i] = atoi(argv[i]);

  printf("%d\n",moneda(d,n,k));

  return 0;
}

