#include <stdio.h>
#include <stdlib.h>

#define MAX_n 100
#define INF 1000000

int moneda (int * d, int n, int k) {
  int acum = 0;
  int m = 0;
  int i;
  div_t qr;

  while (acum < k) {
    i = n-1;
    while (i >= 0 && acum + d[i] > k) i--;
    if (i < 0) return INF;
    qr = div(k - acum, d[i]);
    m = m + qr.quot;
    acum = k - qr.rem;  
  }
  return m;
}

int main (int argc, char *argv[]) {
  int d[MAX_n];
  int i;

  int k = atoi(argv[argc-1]);
  int n = argc - 2;

  if (n < 1 || n > MAX_n) {
    printf("Wrong number of arguments.\n");
    return 1;
  }

  for (i = 0; i < n; i++) d[i] = atoi(argv[i+1]);

  printf("%d\n",moneda(d,n,k));

  return 0;
}

